Subject: Re: IUAP: Bit order in DLCI field

From: Eva Weilandt <[email-masked]>
Date: Tue, 28 Aug 2001 08:27:41 +0200

Any news on this?

Hi Ken,

I talked to the guy who implemented the IUAP and SCTP stacks for PRI
here at Nortel, and
I'm still not sure if the IUA standards shows the DLCI value in the
right way. He gave me
an example on the SCTP payload information (as shown below), where they
first coded
"|Reserved|U|B|E|" as 0x192 (for B and E as 1), but changed it because
everybody else was
coding it as 0x03.
This would indicate that you should read the bits from left to right:
00000011 -> 0x03

       0                   1                   2                   3
       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |   Type = 0    | Reserved|U|B|E|    Length                     |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

When I now look at the DLCI parameter as given in V5UA:

       0                   1                   2                   3
       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |0|S|  SAPI     |1|      TEI    |                               |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

For SAPI = 63 and TEI = 10, the same way of reading it would give:
00111111 10001010  ->  0x3f8a

What I can tell from DLCI as coded according to Q.921, the correct value
would be (just the
other way round):

1111110000010101 -> 0xfc15

And this is correct, I verified it with real traces (for V5, but this is
the same anyway).

You are sure that the DLCI is shown correctly in the IUAP? Or what do I
do wrong?

Regards,

Eva

Ken Morneault wrote:

> Eva,
>
> Sorry for the delayed response.  Please see below.
>
> Regards,
>
> Ken
>
> At 08:19 AM 8/6/01 +0200, you wrote:
> >Hi Ken,
> >
> >I'm just wondering if this definition of the DLCI field in IUA is on
> >purpose? It seems to be just the other way round as it is defined in Q.921.
> >
> >
> >        0     1     2     3     4     5     6     7
> >     +-----+-----+-----+-----+-----+-----+-----+-----+
> >     |  0  | SPR |      SAPI                         |
> >     +-----------------------------------------------+
> >     |  1  |            TEI                          |
> >     +-----------------------------------------------+
> >                                                 IUA definition
> >
> >
> >        8     7     6     5     4     3     2     1
> >     +-----+-----+-----+-----+-----+-----+-----+-----+
> >     |      SAPI                         | C/R |  0  |
> >     +-----------------------------------------------+
> >     |            TEI                          |  1  |
> >     +-----------------------------------------------+
> >                                                 Q.921 definition
> >
> >I just stumbled over this for V5UA, it would mean that we can not just copy
> >this field but have to reformat it when we then use it for the V5 interface.
> >Or am I completely wrong?
>
> Please consider that the lsbit is transmitted first and msbit is
> transmitted last.
>
> >The sentence ' The DLCI field (including the SAPI and TEI) is coded in
> >accordance with Q.921.'  in the IUAP then is a little bit missleading,
> >that's what confused me in the first time.
>
> >Regards,
> >
> >Eva
> >

--
------------------------------------------------

Dr. Eva Weilandt

V5.2 Development

Nortel Networks Germany

88039 Friedrichshafen / Germany

Tel. +49-7545-96-7267     Fax +49-7545-96-8160

ESN 565-7267

---
You are currently subscribed to sigtran as: [email-masked]
To unsubscribe send a blank email to [email-masked]